*! version 0.2.2 2012-11-09 | scott long | name
*! version 0.2.1a 2012-10-28 | scott long | cleanup
* version 0.2.0 2012-10-28 | scott long

** operations on rows or columns of a matrix

* todo: add sd
* todo: add coleq and rowed

capture program drop _matrc

program _matrc

    version 11.2

    local rc "`1'"
    local matin "`2'"
    local doargs = 1 // continue processing args
    local list ""
    if "`rc'"=="row" local concat " \ "
    else local concat " , "
    * is a matrix specified?
    if "`matin'"=="" {
        display "Syntax for mat`rc':"
        display
        display "   mat`rc' <matrix> `rc'#out = `rc'#L [ + - / * %] `rc'#R"
        display "                   `rc'#out name <`rc' name>"
        display "                   keep <`rc' #s to keep>"
        display "                   drop <`rc' #s to drop>"
        display "                   number : add #'s to `rc' names"
        display "                   names <`rc' names>"
        display ///
        "                   [sum mean sd]    <= add `rc' with statistics"
*        display ///
*        "   mat`rc' <matrix> <= list matrix or add list to end of command"
        exit
    }

//  does matin exist?

    capture matrix list `matin'

    * matrix exists
    if _rc==0 {
        local nrows = rowsof(`matin')
        local ncols = colsof(`matin')
        local rownms : rownames `matin'
        local colnms : colnames `matin'
    }
    * matrix does not exist
    else {
        display as error ///
            "matrix `matin' does not exist"
        exit
    }

    local isnum "`3'"
    local nextarg = 4

//  -matrc matin- only

    if "`isnum'"=="" {
        matlist `matin'
        exit
    }

//  -matrc matin names ...- to get new rc names?

    if "`isnum'"=="names" {
        local rcnms ""
        local i = `nextarg'
        while "``i''"!="" {
            local rcnms "`rcnms'``i'' "
            local ++i
        }
        local op "names"
        local doargs = 0 // no more args to process
    }

//  -matrc matin # ...- or -matrc matin <word>- ?

    capture confirm integer number `isnum'

    * matin <word> syntax
    if _rc != 0 & `doargs' {
        local op "`isnum'"
        local okop = ///
        inlist("`op'","drop","names","keep","number","sum","mean","sd")
        if `okop'!=1 {
            display as error ///
                "invalid operation `op' <1>"
            exit
        }
        * rest of syntax decoded below as each operation is executed
    }

    * matin # syntax
    else if _rc == 0 & `doargs' {

        local rc_outnum = `isnum'

        local isequal "``nextarg''"
        local ++nextarg

        * -matrc matin #- needs more input
        if "`isequal'"=="" {
            display as error ///
                "invalid syntax <2>"
            exit
        }

        * matin # name syntax
        if "`isequal'"=="name" {
            local op "name"
            local rcnm "``nextarg''"
            local ++nextarg
            if "`rcnm'"=="" {
                display as error ///
                "-mat`row' <matnm> name- must have `rc' name specified <3>"
                exit
            }
            local argis"``nextarg''"
            if "`argis'"=="list" local list "list"
            local doargs = 0 // no more args to process
        }

        * matin # = syntax
        else if "`isequal'"=="=" {

            local rc_Lnum "``nextarg''"

            local ++nextarg
            local op "``nextarg''"

            local ++nextarg
            local rc_Rnum "``nextarg''"

            local ++nextarg

            if "`rc_Lnum'"=="" | "`op'"=="" | "`rc_Rnum'"=="" {
                display as error ///
                    "invalid syntax, incomplete command <4>"
                exit
            }

            * is operator valid?
            local okop = inlist("`op'","+","-","*","/","%")
            if `okop'!=1 {
                display as error ///
                    "invalid `rc' operator `op' <5>"
                exit
            }

            * is L number valid?
            capture confirm integer number `rc_Lnum'
            if _rc != 0 {
                display as error ///
                "invalid syntax: `isnum' must be a number <6>"
                exit
            }
            if `rc_Lnum'>`n`rc's' {
                display as error ///
                "`rc' number `rc_Lnum' exceeds matrix dimensions <7>"
                exit
            }

            * is R number valid?
            capture confirm integer number `rc_Rnum'
            if _rc != 0 {
                display as error ///
                "invalid syntax: `isnum' must be a number <8>"
                exit
            }
            if `rc_Lnum'>`n`rc's' {
                display as error ///
                "`rc' number `rc_Rnum' exceeds matrix dimensions <9>"
                exit
            }

            local nextoption "``nextarg''"
            if "`nextoption'" == "list" {
                local list "list"
            }
            else {
                * perhaps other options will be added
            }
            local doargs = 0 // no more args to process

        } // matin # = syntax

        else {
            display as error ///
                "incorrect syntax <10>"
            exit
        }

        }
/*
di "matin:      `matin'"
di "rc_outnum:  `rc_outnum'"
di "rc_Lnum:    `rc_Lnum'"
di "op:         `op'"
di "rc_Rnum:    `rc_Rnum'"
di "rcnm:       `rcnm'"
di "names:      `rcnms'"
di "nextarg:    `nextarg'"
di "doargs:     `doargs'"
*/

//  run operations

    capture matrix drop matout

//  drop or keep rows/columns

    if "`op'"=="drop" | "`op'"=="keep" {
        local rclist ""
        local i = `nextarg'
        while "``i''"!="" {
            local rclist "`rclist'``i'' "
            local ++i
        }
    }

    if "`op'"=="drop" {
        local newrcnms ""
        forvalues i = 1(1)`n`rc's' {
            if "`rc'"=="row" {
                matrix ivec = `matin'[`i',1...]
            }
            else  {
                matrix ivec = `matin'[1...,`i']
            }
            local ipos : list posof "`i'" in rclist
            if `ipos'== 0 {
                local inm : word `i' of ``rc'nms'
                local newrcnms "`newrcnms'`inm' "
                matrix matout = nullmat(matout) `concat' ivec
            }
        }
    }

    if "`op'"=="keep" {
        local newrcnms ""
        foreach i in `rclist' {
            if `i'<=`n`rc's' {
                if "`rc'"=="row" {
                    matrix ivec = `matin'[`i',1...]
                }
                else  {
                    matrix ivec = `matin'[1...,`i']
                }
                local inm : word `i' of ``rc'nms'
                local newrcnms "`newrcnms'`inm' "
                matrix matout = nullmat(matout) `concat' ivec
            }
            else {
                display "`rc' `i' is not in matrix"
            }
        }
    }

//  number row col names

    if "`op'"=="number" {
        matrix matout = `matin'
		local newnms ""
		local i = 0
		foreach nm in ``rc'nms' {
			local ++i
			local newnms "`newnms' `i'_`nm'"
		}
		matrix `rc'names matout = `newnms'
	}

//  sum mean sd

    if "`op'"=="sum" | "`op'"=="mean" | "`op'"=="sd" {

        local argis "``nextarg''"
        if "`argis'"=="list" local list "list"

        matrix matout = `matin'
        if "`rc'"=="col" matrix matout = matout'
        mata: matout = st_matrix("matout")

        if "`op'"=="sum" {
            mata: vecout = colsum(matout)
        }
        if "`op'"=="mean" {
            mata: vecout = mean(matout)
        }
        mata: st_matrix("vecout",vecout)
        matrix rownames vecout = `op'
        matrix colnames vecout = `rc'nms

        if "`rc'"=="row" {
            matrix matout = `matin' \ vecout
        }
        if "`rc'"=="col" {
            matrix vecout = vecout'
            matrix matout = `matin' , vecout
        }
	}
/*
    if "`op'"=="sd" {
	}
*/

//  names for all rows or columns

    if "`op'"=="names" {
        local nrcnms = wordcount("`rcnms'")
        if `nrcnms' != `n`rc's' {
            display as error ///
            "# of names does not match number of `rc's"
            exit
        }
        matrix matout = `matin'
		matrix `rc'names matout = `rcnms'
    }

//  name for given row or column

    if "`op'"=="name" {
        local oldnms : `rc'names `matin'
        local noldnms = wordcount("`oldnms'")
        local newnms ""
        forvalues i=1(1)`noldnms' {
            local addnm : word `i' of `oldnms'
            if `i'!=`rc_outnum' {
                local newnms "`newnms'`addnm' "
            }
            else local newnms "`newnms'`rcnm' "
        }
        matrix matout = `matin'
		matrix `rc'names matout = `newnms'
    }

//  math

    local ismath = inlist("`op'","+","-","*","/","%")
    if `ismath' {
*di "`concat' concat is"
        * get the vectors
        if "`rc'"=="row" {
            matrix vecL = `matin'[`rc_Lnum',1...]
            matrix vecR = `matin'[`rc_Rnum',1...]
        }
        else {
            matrix vecL = `matin'[1...,`rc_Lnum']
            matrix vecR = `matin'[1...,`rc_Rnum']
        }

        mata: vL = st_matrix("vecL")
        mata: vR = st_matrix("vecR")

        if "`op'"=="-" {
            mata: vecout = vL :- vR
        }
        if "`op'"=="+" {
            mata: vecout = vL :+ vR
        }
        if "`op'"=="*" {
            mata: vecout = vL :* vR
        }
        if "`op'"=="/" {
            mata: vecout = vL :/ vR
        }
        if "`op'"=="%" {
            mata: vecout = 100*(vR :/ vL)
        }
        mata: st_matrix("vecout",vecout)

*mat list vecout

        * null vector if new vector exceeds dimensions
        local addvec = 0
        if `rc_outnum'>`n`rc's' {
            local addvec = 1
            if "`rc'"=="row" {
                matrix vecnull = J(1,`ncols',.z)
                matrix rownames vecnull = _
                matrix colnames vecnull = `colnms'
            }
            else {
                matrix vecnull = J(`nrows',1,.z)
                matrix colnames vecnull = _
                matrix rownames vecnull = `rownms'
            }
        }
        * build new matrix
        local newvecnm "`rc_Lnum'_`op'_`rc_Rnum'"
        forvalues ivec = 1(1)`n`rc's' {
            local vecnm : word `ivec' of ``rc'nms'
            if "`rc'"=="row" {
                matrix vecis = `matin'[`ivec',1...]
            }
            else {
                matrix vecis = `matin'[1...,`ivec']
            }
            * in ivec is output location, add to matrix
            if `ivec'==`rc_outnum' {
                * name rowcol with operation
                matrix rowname vecout = `newvecnm'
                matrix matout = nullmat(matout) `concat' vecout
            }
            else {
                matrix matout = nullmat(matout) `concat' vecis
            }
        }
        if `addvec' {
            local nplus1 = `n`rc's' + 1
*di "addvec: `addvec'  outnum: `rc_outnum' nplus1 `nplus1' "
            forvalues ivec = `nplus1'(1)`rc_outnum' {
                if `ivec'==`rc_outnum' {
                    matrix rowname vecout = `newvecnm'
                    matrix matout = nullmat(matout) `concat' vecout
                }
                else {
                    matrix matout = nullmat(matout) `concat' vecnull
                }
            }
        }
    } // math operators

//  done with math operators

    matrix `matin' = matout
    _closeup `matin' `list'

end

program _closeup

    args mat list
    capture matrix drop matout
    capture matrix drop vecout
    capture matrix drop vecnull
    capture matrix drop vecR
    capture matrix drop vecL
    capture matrix drop ivec

    if "`list'"=="list" {
        matlist `mat'
    }
end

exit
