*! version 1.0.5 2012-10-03 | long freese | mprobit return name

** returns names and number of rhs variables in eq 1 and 2 of model
** syntax: _rm_rhsnames rhsNMS1 rhsN1 rhsNMS2 rhsN2

program define _rm_rhsnames

	version 11.2
    args rhsNMS1 rhsN1 rhsNMS2 rhsN2

	local cmd "`e(cmd)'"
    local RHSnmsALL : colnames e(b)
	local RHSnmsALL : subinstr local RHSnmsALL "_cons" " ", all // ologit etc

    if "`cmd'"=="mlogit" | "`cmd'"=="mprobit" {
        local RHSnmsALL : subinstr local RHSnmsALL "o. " "", all // mlogit
        if (e(ibaseout)==1 | e(i_base)==1) local enum 2 // mlogit
        else local enum 1
        _ms_extract_varlist `RHSnmsALL', noomit eq(#`enum') nofatal
        local RHSnms1 "`r(varlist)'"
        local RHSn2 = 0
        local RHSnms2 ""
        local RHSn1 : word count `RHSnms1'
    }
    else {
        * zip and zinb have two equations
        local eqns = 1 + cond("`cmd'"=="zip" | "`cmd'"=="zinb",1,0)
        forvalues i = 1/`eqns' {
            if `eqns' == 1 _ms_extract_varlist `RHSnmsALL', noomit
            else  _ms_extract_varlist `RHSnmsALL', noomit eq(#`i') nofatal
            local RHSnms`i' `r(varlist)'
      	    local RHSn`i' : word count `RHSnms`i''
        }
    } // not mlogit

	c_local `rhsNMS1'    "`RHSnms1'"
	c_local `rhsN1'      `RHSn1'
	c_local `rhsNMS2'    "`RHSnms2'"
	c_local `rhsN2'      `RHSn2'

end

exit

* version 1.0.0 2012-08-08 scott long
* version 1.0.1 2012-09-04 jsl | remove 0b. | posted
* version 1.0.2 2012-09-05 jsl | fix nvars in mlogit | posted
* version 1.0.3 2012-09-12 | long freese | fix mlogit base()
* version 1.0.4 2012-09-12 | long freese | new mlogit routine

PRIOR CODE:
*	local RHSnmsALL : subinstr local RHSnmsALL "o. " "", all // for mlogit

        * taking set of mlogit coef; o. ok but remove o. from name
        local RHSnmsALL : subinstr local RHSnmsALL "o." ".", all
        local RHSnmsALL : subinstr local RHSnmsALL " ." " ", all
        local RHSn1 : word count `RHSnmsALL'
        local RHSn1 = `RHSn1' / `e(k_out)'
        local RHSnms1 ""
        local space ""
        forvalues i = 1(1)`RHSn1' {
            local nm : word `i' of `RHSnmsALL'
            local ipos = regexm("`nm'","0b.")
            if `ipos'==0 {
                local RHSnms1 "`RHSnms1'`space'`nm'"
                local space " "
            }
        }
