
{smcl}
{* 2013-03-12 scott long & jeremy freese}{...}
{hi:help fitstat}{right:See also: {helpb spost13}}
{hline}

{title:Scalar measures of fit for regression models}

{p2colset 5 16 24 2}{...}
{p2col:{cmd:fitstat} {hline 2}}Compute measures of fit for estimated model{p_end}
{p2colreset}{...}

{title:Syntax}

{p 4 18 2}
{cmd:fitstat}{cmd:,} [ {opt save} {opt dif:f} {opt s:aving(name)} {opt u:sing(name)} {opt force} {opt ic}   ]
{p_end}

{marker overview}
{title:Overview}

{pstd}
{cmd:fitstat} is a post-estimation command that computes a variety of measures
of fit for many kinds of regression models.  It works after the following:
{cmd:clogit}, {cmd:cnreg}, {cmd:cloglog}, {cmd:intreg}, {cmd:logistic}, {cmd:logit}, {cmd:mlogit}, {cmd:nbreg}, {cmd:ocratio},
{cmd:ologit}, {cmd:oprobit}, {cmd:poisson}, {cmd:probit}, {cmd:regress}, {cmd:zinb}, {cmd:zip}, {cmd:ztnb}, {cmd:zip}.  With
the {opt save} and {opt diff} options (or {opt s:aving()} and {opt u:sing()}), it can also be used to compare fit measures for two
different models.
{p_end}

{pstd}
For all models, {cmd:fitstat} reports the log-likelihoods of the full and
intercept-only models, the deviance (D), the likelihood ratio chi-square
(G2), Akaike's Information Criterion (AIC), AIC/N, the Bayesian Information
Criterion (BIC).
{p_end}

{pstd}
For all models except {cmd:regress}, {cmd:fitstat} reports McFadden's R2, McFadden's
adjusted R2, the maximum likelihood R2, and Cragg & Uhler's R2.  These
measures all equal R2 for OLS regression.  {cmd:fitstat} reports R2 and the
adjusted R2 after {cmd:regress}.
{p_end}

{pstd}
fitstat reports the regular and adjusted count R2 for categorical data models.
For ordered or binary logit or probit models, as well as models for censored
data ({cmd:tobit}, {cmd:cnreg}, or {cmd:intreg}), it also reports McKelvey and Zavonia's R2.
In addition, it reports Efron's R2 for {cmd:logit} or {cmd:probit}, and reports Tjur's 
Coefficient of Discrimination for binary outcome models.
{p_end}

{pstd}
Not all measures are provided for models estimated with pweights or iweights.
{p_end}

{title:Options}

{p2colset 5 20 21 0}
{synopt:{opt save}} saves the computed measures in a matrix for subsequent comparisons.
{p_end}

{p2colset 5 20 21 0}
{synopt:{opt dif:f}} compares the fit measures for the current model with those 
previously saved using {opt save}.
{p_end}

{p2colset 5 20 21 0}
{synopt:{opt s:aving(name)}} and {opt u:sing(name)}} are the equivalent of {opt save} 
and {opt diff} but allow you to refer to saved results by name.  The name cannot be 
longer than four characters.
{p_end}

{p2colset 5 20 21 0}
{synopt:{opt force}} will compare two models even when the number of observations or 
the estimation method varies between the two models.
{p_end}

{p2colset 5 20 21 0}
{synopt:{opt ic}} only presents information measures.  These include alternative 
specifications of BIC based on the deviance and the likelihood ratio chi-squared 
(sometimes referred to as BIC').
{p_end}

{title:Examples}

{pstd}To compute fit statistics for a single model:{p_end}

{phang2}{cmd:. use mroz,clear}{p_end}
{phang2}{cmd:. logit lfp k5 k618 age wc hc lwg inc}{p_end}
{phang2}{cmd:. fitstat}
{p_end}

{pstd}To obtain AIC- and BIC-based measures only:{p_end}

{phang2}{cmd:. fitstat, ic}
{p_end}

{pstd}To compare fit statistics for models:{p_end}

{phang2}{cmd:. logit lfp k5 k618 age wc hc lwg inc}{p_end}
{phang2}{cmd:. fitstat, save}{p_end}
{phang2}{cmd:. logit lfp k5 k618 age age2 wc hc lwg inc}{p_end}
{phang2}{cmd:. fitstat, diff}
{p_end}

INCLUDE help spost13_footer
