{smcl}
{* 2013-05-01 scott long}{...}
{hi:help mgen}{right:See also: {helpb spost13}, {helpb margins}}
{hline}

{p2colset 5 13 24 2}{...}
{p2col:{cmd:mgen} {hline 2}}{cmd:mgen} generate variables with predictions
from {cmd:margins}{p_end}
{p2colreset}{...}

{marker overview}
{title:Overview}

{pstd}
{cmd:mgen} generates variables with predictions and related
statistics from {cmd:margins}.
In addition, variables which summarize predictions over the sample
are created which can be used for plotting.


{title:General syntax}

{p 4 8 2}
{cmd:mgen}{cmd:,}
 [ mgen-options margins-options ]


{title:Table of contents}

    {help mgen##margins:Options for margins}
    {help mgen##name:Naming variables}
    {help mgen##stats:Which variables are generate without the meanpred option}
    {help mgen##meanpred:Variables generate with the meanpred option}
    {help mgen##model:How mgen works with various types of models}
    {help mgen##other:Miscellaneous options}
    {help mgen##examples:Examples}


{title:Options}
{marker margins}
{dlgtab:Options for margins}
{p2colset 7 24 25 0}
{p 6 6 2}
Most options from {cmd:margins} can be used with this
command. Notably {cmd:at()} can be used to specify values of
independent variables at which predictions are to be calculated.
For example, {cmd:at(age=( 20(5)85 )}. See {help margins##at_op:at(atspec)} for details.

{marker name}
{dlgtab:Naming and summarizing variables}
{p2colset 9 24 25 0}
{p 6 6 2}
Variables that are generated have names of the form: <stub><statistic><category>.
The <stub> is common to all variables created in a given {cmd:mgen} comamnd.
<statistic> are names that describe the statistic in the variable
(e.g., {bf:se} indicates a standard error). <category> is the value or the
value label of the outcome category; for some models there is no <category>.
Details on controlling the names are given in this section. Go to
{help mgen##stats:which variables are generated} for selecting statistics.

{synopt:{opt stub(stubname)}}
All variables generated will begin with {it:stubname}.
If unspecified, default is "_".
{p_end}

{synopt:{opt predn:ame(string)}}
By default variables are names used the expression name
used by {cmd:margins} for the quantity being predicted.
For example, the name is {cmd:pr} for probabilities based on {cmd:logit}.
If you want a different name, use the {cmd:predname()} option.
{p_end}

{synopt:{opt predl:abel(string)}}
The label is used to describe the predictions in variable labels of
generated variables.
By default, the name from {cmd:predname()} is used.
{p_end}

{synopt:{opt nol:abel}}Do not use value labels from the outcome
variable for <category>. For example, use the
name <stub><statistic>{bf:1} rather than <stub><statistic>{bf:SR}
where SR is the value label for category 1 of the outcome.
{p_end}

{synopt:{opt valuel:ength(integer)}}
limits length of value labels used for <category> to label variables.
{p_end}

{marker stats}
{dlgtab:Which variables are generated}

{p 6 6 2}
Variables generated by {cmd:mgen} include estimates and related statistics from
{cmd:margins} and value from the {bf:at()} matrix in {cmd:margins}.

{p 6 6 2}
The following names are used for the statistics that can be saved to variables.

{p2colset 10 23 22 12}{...}
{p2col :<statistic>}Description{p_end}
{p2line}
{p2col :{it:predname}}Estimate such as probabilities, dydx, etc.{p_end}
{p2col :{bf:ll}}Lower level bound of confidence interval{p_end}
{p2col :{bf:ul}}Upper level bound of confidence interval{p_end}
{p2col :{bf:pval}}p-value for test margin is 0{p_end}
{p2col :{bf:se}}Standard error of margin{p_end}
{p2col :{bf:z}}z-value of test prediction is 0{p_end}
{p2line}
{p2colset 7 24 24 0}
{p 6 6 2}
By default, variables are generated with the estimate
and the upper and lower bounds of the confidence interval.
Other statistics can be requested with these option:

{synopt:{opt alls:tats}}
Variables with all statistics are generatged.
{p_end}

{synopt:{opt noci}}
Only a variable with the estimates is generated.
{p_end}

{synopt:{opt cond:itional}}
Conditional rather than unconditional probabilities are to be
computed as estimates for models in
which {cmd:predict} supports {bf:cpr(}{it:#}{bf:)} (e.g., {cmd:tpoisson}).
{p_end}

{synopt:{opt force}}
Forces the computation of predictions for count
models where the dependent variable has non-integer values.
{p_end}

{synopt:{opt out:comes(numlist)}}
Variables are generated for these values of the outcome.
{cmd:outcomes()} requires the estimation model to be
"categorical", "binary", or "count", where these are
defined by the behavior of the {cmd:predict} command as described
under "Model Types" in {helpb mgen}.
Outcome values must be non-negative integers.
{p_end}

{p 6 6 2}
Values of independent variables in at() are saved as
<stub>{it:varname}.

{synopt:{opt atv:ars(varlist)}}
By default, variables are generated only for those independent variables
that vary within {cmd:at()}.
All variables can be included by specifying _all; none by specifying _none.
{p_end}

{marker meanpred}
{dlgtab:Which variables are generated with the meanpred option}
{p2colset 9 24 25 0}
{synopt:{opt meanp:red}}
Generates additional variables where each observation is for a
specific value of the at-variable that is changing.

{p 6 6 2}
The {cmd:meanpred} option can only be used for models for count outcomes.
Variables are created based on based on observed proportions in the
estimation samples, average predictions, and the value of the outcome
being predicted (e.g., value 7 for predictions of a count equal to 7).
The following variables are created where {it:stub} is the string
set by {cmd:stub()}.

{p2line}
{p2col :{it:stub}val}Value of the outcome{p_end}
{p2col :{it:stub}obeq}Observed proportion y = {it:value}{p_end}
{p2col :{it:stub}oble}Observed proportion y <= {it:value}{p_end}
{p2col :{it:stub}preq}Predicted proportion y = {it:value}{p_end}
{p2col :{it:stub}prle}Predicted proportion y <= {it:value}{p_end}
{p2col :{it:stub}obpr}Difference between observed and predicted proportions of y = {it:value}{p_end}
{p2col :{it:stub}cpreq}Average predicted Pr(y={it:value} | y>0) (if conditional option specified){p_end}
{p2col :{it:stub}cprle}Average predicted Pr(y<={it:value} | y>0) (if conditional option specified){p_end}
{p2line}

{marker model}
{dlgtab:Model types}
{p2colset 9 24 25 0}
{p 6 6 2}
{cmd:mgen} exhibits different default behavior depending on
what options are permitted by {cmd:predict}.
For convenience, three major types of models are called "categorical",
"count", and "binary" models.

{p2line}
{p2col :categorical}{cmd:predict} allows {cmd:outcome({it:#})}, such as {cmd: mlogit}{p_end}
{p2col :count}{cmd:predict} allows {cmd:pr({it:#})}, such as {cmd: poisson}{p_end}
{p2col :binary}{cmd:predict} default is {cmd:pr}, such as {cmd: logit}{p_end}
{p2col :other}None of the above, such as {cmd: regress}{p_end}
{p2line}

{p 6 6 2}
A categorical or binary model assume all outcomes
unless either {cmd:outcome()} is specified
or the marginal prediction to be calculated is specified
using either {cmd:margins} options {cmd:predict()} or {cmd:expression()}.

{p 6 6 2}
Cumulative predictions are calculated for categorical and count outcomes,
unless {cmd:outcome()} is used to specify values that exclude
a subset of the lowest observed values of the outcome.


{marker other}
{dlgtab:Miscellaneous options}
{p2colset 9 24 25 0}
{synopt:{opt d:etail}}
Show details output from {cmd:margins}. By default only a summary of what
was done is shown.
{p_end}


{marker examples}
{dlgtab:Examples}
{p2colset 7 24 25 0}
{p 6 6 2}

    {hline}


    {hline}


{title:Also see}

{pstd}
Manual: {hi:[R] margins}

INCLUDE help spost13_footer
