{smcl}
{* 2013-03-28 jeremy freese & scott long}{...}
{hi:help mlistat}{right:also see: {helpb mpost}; {helpb margins}}
{hline}

{title:List r(at) matrix computed by {cmd:margins} : 21Aug2012}

{p2colset 5 16 13 2}{...}
{p2col:{cmd:mlistat} {hline 2}}{cmd:mlistat} lists
{cmd:margins}'s r(at) matrix | 02Jul2012{p_end}
{p2colreset}{...}

{marker overview}
{title:Overview}

{pstd}
{cmd:margins} uses the r(at) matrix from {cmd:margins}
to hold the values of the predictors
at which predictions are computed.
{cmd:mlistat} presents these divided into the constant and varying values, and allows you to list values for selections of variables.


{title:General syntax}

{p 4 8 2}
{cmd:mlistat} [{it:your_matrix}]{cmd:,}
[
{opt at:vars(select_at_variables)}
{opt nos:plit}
{opt noc:onstant}
{opt nov:ary}
{opt savec:onstant(matname)}
{opt savev:arying(matname)}
{opt omit}
{opt qui:etly}
{opt roweq:nm(row_eq_name_to_add)}
{opt dec:imals(decimal_digits)}
{opt width(column_width)}
]

{p 5 5 2}
where {it:your_matrix} is the matrix where results are saved.
If no matrix is specified, no matrix is saved.
{p_end}

{p2colset 5 24 25 0}
{p2col:{opt at:vars(varlist)}}
list only the at variables specified. For example,
{cmd:atvars(k5 wc)} or {cmd:atvars(1(1)3)}.
{p_end}

{synopt:{opt nos:plit}} do not divide output into constant and varying at() values
{p_end}

{synopt:{opt noc:onstant}} do not print at() values that are constant
{p_end}

{synopt:{opt savec:onstant(matname)}} save constant at() values as matrix
{p_end}

{synopt:{opt savev:arying(matname)}} save varying at() values as matrix
{p_end}

{synopt:{opt omit}} print column values for base levels and other omitted variables
{p_end}

{synopt:{opt qui:etly}} results are not printed
{p_end}

{synopt:{opt coleq:nm(column_stub)}}
add the equation name {it:column_stub} to the columns in the matrix where
the results are saved.
For example, {opt coleqstub("Model 1")} adds add "Model 1" above
columns with the results.
{p_end}

{synopt:{opt roweq:nm(row_stub)}} add the equation name {it:row_stub} to the rows where results are saved.
{p_end}

{synopt:{opt dec:imal(numlist)}} set the number of decimal digits
for each column when listing the matrix.
Columns can have different numbers of decimal digits.
For example, {cmd:mlistat, decimal(3 2 2)}.
{p_end}

{synopt:{opt width(number)}} specify the width of the columns
{p_end}


{marker examples}{...}
{title:Examples}

    {hline}

{pstd}{bf:Quickly list matrix}{p_end}

{phang2}mlistat1{p_end}

    {hline}

{pstd}{bf:List only some values in at() matrix}{p_end}

{phang2}mlistat1, atvar(wc k5){p_end}

    {hline}

{pstd}{bf:Add a column equation label}{p_end}

{phang2}mlistat1 MyAtValues, rnumber atvar(wc k5) coleqstub(Model_1){p_end}

    {hline}


{title:Also see}

{pstd}
Manual: {hi:[R] margins}

INCLUDE help spost13_footer
