*! version 0.8.13 2013-04-22 | long freese | n is
* version 0.8.12 2013-03-28 | long freese | if in; twidth(); better name parsing; spaces in names
* version 0.8.11 2013-03-25 | long freese | stat(ci) tweak
* version 0.8.10 2013-03-22 | long freese | stat(ci)
* version 0.8.9 2013-03-13 | long freese | mtable no options
* version 0.8.8 2013-03-02 | long freese | est is default; ci options
* version 0.8.7 2013-02-28 | long freese | option clean

//  table of margins results

* note: if mtable, at(a=1)     : a is only listed in table with atvar(a)
* note: if mtable, at(a=(0 1)) : a is listed in table

capture program drop _parse_stat
capture program drop _MarginsParse
capture program drop _GetModelType
capture program drop mtable
program define mtable

    version 11.2

    syntax [if] [in] , [ ///
    ///
    /// r(at)
        NOATvars /// atvars(_none)
        ATVars(string asis) /// select and rename r(at) variables
        ATRight /// at matrix at right of table; default is atleft
        mlistat /// run mlistat at end
    /// stats
        STATS(string asis) /// synonym for statistics
        STATistics(string asis) /// estimate ul ll z se p start end
        ALLSTats /// generate all stats (p, z, se, level)
        CI /// show estimate and CI
        PValue /// show estimate and pvalue
    ///
        CPR /// run predict(cpr(*)) for counts
    /// stacking
        below /// put new results below old
        right /// put new results to right
        CLEARstack /// delete stack matrix
    /// output format
        NOBS /// list nobs
        long wide /// which to print
        COLSTub(string) ///
        ROWSTub(string) /// add stub to added row names
        ROWName(string) /// name for row names
        ROWEQnm(string) /// add row eq name
        COLEQnm(string) /// add col eq name
        NOLabels /// whether to use value labels
        VALUELength(numlist >0 integer) ///
        OUTcomes(string asis) /// predict values
        title(string) /// Title when listing
        DECimals(integer 3) /// Digits when list matrix
        WIDth(integer 8) /// Column width when listing matrix
        Details /// show margins results
        ESTName(string asis) /// allow override of margin name
        NAMes(string) /// Rows Columns All None used by matlist
        TWidth(integer 0) ///
      * /// everything else will get passed along
        ]

    tempname atvec atsrc atintable atL tbluse statcolmat outmat ivec
    tempname priormat currentmat margins outmatlong

//  atvars

    matrix `atintable' = J(1,1,.)
    if ("`noatvars'"=="noatvars") local atvars ""
    if "`atvars'"=="_none" {
        local noatvars "noatvars"
        local atvars ""
    }

//  stats

    if ("`stats'"!="" & "`statistics'"=="") local statistics "`stats'"
* 0.8.11
    local statistics : subinstr local statistics "ci" "estimate ll ul", all
    local statlist "estimate" // default statistics
    local tablecolnms  "estimate se z pvalue ll ul" // names for matrix columns
    * show all statistics
    if ("`allstats'"=="allstats") local statlist "`tablecolnms'"
    if "`statistics'"=="all" {
        local statlist "`tablecolnms'"
        local statistics ""
    }
    *
    else if ("`ci'"=="ci") local statlist "estimate ll ul"
    else if ("`pvalue'"=="pvalue") local statlist "estimate pvalue"
    else if "`statistics'"!="" {
        local new ""
        foreach opt in `statistics' {
            _parse_stat `opt'
            local newopt
            local stat "`s(stat)'"
            local new "`new'`stat' "
            if "`s(isbad)'"=="1" {
                display as error "invalid statistic specified: `opt'"
                exit
            }
        }
        local statlist "`new'"
    }
    if ("`s(isbad)'"=="1") exit

    local statlist : list uniq statlist
    local nstats = wordcount("`statlist'")
    local nm_se "se"
    local nm_z "z"
    local nm_pvalue "p" // "pvalue"
    local nm_ll "ll"
    local nm_ul "ul"
    local nm_estimate "estimate"

//  syntax

    local nonamesopt = 1
    if ("`names'"!="") local nonamesopt = 0

    local isbad = 0
    if "`long'"=="long" & "`wide'"=="wide" {
        display as error ///
            "options wide and long cannot be used together"
        local isbad = 1
    }
    if "`noatvars'"=="noatvars" & "`mlistat'"=="mlistat" {
        display as error ///
            "options noatvars and mlistat cannot be used together"
        local isbad = 1
    }
    if "`e(cmd)'"=="ztnb" | "`e(cmd)'"=="ztp" {
        display as error ///
            "use tpoisson or tnbreg instead of ztp or ztnb"
        local isbad = 1
    }
    if "`wide'"=="wide" & "`long'"=="long" {
        display as error ///
            "options long and wide cannot be used together"
        local isbad = 1
    }
    if "`below'"=="below" & "`right'"=="right" {
        display as error ///
            "options below and right cannot be used together"
        local isbad = 1
    }
    if ("`clearstack'"=="clearstack") capture matrix drop _mtab_stack
    if "`clearstack'"=="clearstack" & "`right'"=="right" {
        display as error ///
            "options clearstack and right can't be used together"
        local isbad = 1
    }
    if "`clearstack'"=="clearstack" & "`below'"=="below" {
        display as error ///
            "options clear and below can't be used together"
        local isbad = 1
    }
    if `isbad' exit

    if ("`below'"=="below") local below = 1
    else local below = 0
    if ("`right'"=="right") local right = 1
    else local right = 0
    local dostack = 0
    local stackexists = 0
    if `right' | `below' {
        local dostack = 1
        capture confirm matrix _mtab_stack
        local stackexists = 1
        if _rc!=0 {
            local stackexists = 0
        }
    }

    local titlestub "" // might use this later
    if ("`title'"!="") local mytitle "`titlestub'`title'"
    local qui "quietly"
    if ("`details'"=="details") local qui ""

    local isall = regexm(" `names'","[ ](a|al|all)")
    local isrow = regexm(" `names'","[ ](r|ro|row|rows)")
    local isnon = regexm(" `names'","[ ](n|no|non|none)")
    local iscol = regexm(" `names'","[ ](c|co|col|colu|column|columns)")
    if ("`names'"=="" | `iscol') local names "columns"
    else if `isrow' local names "rows"
    else if `isall' local names "all"
    else if `isnon' local names "none"
    else {
        display as error "invalid names() option"
        exit
    }

//  decode model and margins options

    _GetModelType // "outcome" (cats); "pr" (count); "p" (binary) or ""
    local ExpType "`s(ExpType)'"
    _MarginsParse, `options'
    local MarginsOptions "`s(options)'" // passthru to margins
    local MarginsPredOpt "`s(predictused)'" // TRUE if predict()
    local MarginsExpOpt "`s(expressionused)'" // TRUE if expression()

//  decode outcome categories for margins loop

    if "`ExpType'" == "outcome" /// only for cat and binary models
            & "`outcomes'" == "" /// if outcome() specified, do not override
            & "`MarginsPredOpt'" == "" { // predict(), expression() not used
        local outcomes "*"
    }
    local outcomes = trim("`outcomes'")
    if "`outcomes'" == "*" | "`outcomes'" == "_all" {
        qui levelsof `e(depvar)' if e(sample)==1, local(outcomes)
    }
    local multipleoutcomes = 0
    local singleoutcome = 1
    if "`outcomes'" != "" {
        numlist "`outcomes'", sort
        local outcomes "`r(numlist)'"
        local multipleoutcomes = 1
        local singleoutcome = 0
    }

//  information for printing and merging

    * W=wide: statistics in columns; L=long: in rows
    if "`wide'"=="" & "`long'"=="" {
        if `multipleoutcomes' local long "long"
        if `singleoutcome' local wide "wide"
    }
    if "`wide'"=="wide" {
        local wide = 1
        local LW "W"
    }
    else local wide = 0
    if "`long'"=="long" {
        local long = 1
        local LW "L"
    }
    else local long = 0

//  if outcome() not specified, execute margins once

    if `singleoutcome' {
        if "`details'"=="details" {
*            display _new ". margins, `MarginsOptions'"
            display _new ". margins `if' `in', `MarginsOptions'"
        }
*        `qui' margins, `MarginsOptions'
        `qui' margins `if' `in', `MarginsOptions'
local nobsis = r(N)
        _rm_marginsinfo

        local expression "`s(expression)'"
        local explabel "`s(explabel)'"
        local expdydxlong "`s(expdydxlong)'"
        if ("`expdydxlong'"!="") local explabel "`expdydxlong'"
        local expname "`s(expname)'"
        local nm_estimate "`expname'"
        * estname() overwrites margins name
        if ("`estname'"!="") local nm_estimate "`estname'"
        else local estname "`expname'"
        matrix `tbluse' = r(table)'
        _return hold `margins'
        _rm_matrix_noomitted `tbluse' row
        _return restore `margins'
        local nrows = rowsof(`tbluse')
    } // single outcome

    if `multipleoutcomes' {
        if "`MarginsPredOpt'"!="" | "`MarginsExpOpt'"!="" {
            display as error ///
                "predict() or expression() not allowed with outcome()"
            exit
        }
        local yLabelName : value label `e(depvar)'
        local inm "" // label for outcome i
        local nouts = 0
        foreach ival of numlist `outcomes' {
            local ++nouts
            local inm "`ival'" // if labels not used, use value
            if "`yLabelName'"!="" & "`nolabels'"!="nolabels" {
                local inm : label `yLabelName' `ival' `valuelength'
            }
            if "`ExpType'" == "outcome" { // categorical
                local PredExp "predict(outcome(`ival'))"
            }
            else if "`ExpType'" == "pr" { // count
                local PredExp "predict(pr(`ival'))"
                if ("`cpr'"=="cpr") local PredExp "predict(cpr(`ival'))"
            }
            else if "`ExpType'" == "p" { // binary
                if (`ival'==0) local PredExp = "1-predict(p)"
                else local PredExp "predict(p)"
            }
            else {
                display as error ///
                    "model predictions not compatible with outcome() list"
                exit
            }
            `qui' display _new "-> `e(depvar)' = `ival' (`inm')"
*            `qui' margins, `MarginsOptions' expression(`PredExp')
            `qui' margins `if' `in', `MarginsOptions' expression(`PredExp')
local nobsis = r(N)
            _rm_marginsinfo
            local expression "`s(expression)'"
            local explabel "`s(explabel)'"
            local expdydxlong "`s(expdydxlong)'"
            if ("`expdydxlong'"!="") local explabel "`expdydxlong'"
            local expname "`s(expname)'"
            local nm_estimate "`expname'"
            if ("`estname'"!="") local nm_estimate "`estname'"
            else local estname "`expname'"
            local tabcolnms "`nm_estimate'_`inm' `nm_se'_`inm' `nm_z'_`inm'"
            local tabcolnms "`tabcolnms' `nm_pvalue'_`inm' `nm_ll'_`inm'"
            local tabcolnms "`tabcolnms' `nm_ul'_`inm'"
            mat `tbluse' = r(table)'
            _return hold `margins'
            _rm_matrix_noomitted `tbluse' row // drop omitted columns
            _return restore `margins'
            matrix tableuse_`ival' = `tbluse'[1...,1..6]
            matrix colnames tableuse_`ival' = `tabcolnms'
            local nrows = rowsof(tableuse_`ival')
        } // over outcomes
    } // if multipe

//  get r(at); savevarying goes in table; saveconstant printed below table

    tempname atconstant atvarying
    capture matrix drop `atintable'
    local cmd = r(cmd)
    * BUG in mlistat won't run after margins, pwcompare
    if `"`cmd'"'!="pwcompare" {
        qui capture ///
            mlistat, savevarying(`atvarying') saveconstant(`atconstant')
    }
    capture confirm matrix `atconstant'
    local isatconstant = 1
    if (_rc!=0) local isatconstant = 0
    capture confirm matrix `atvarying'
    local isatvarying = 1
    local noatprint = 0 // don't print at results
    if (_rc!=0) local isatvarying = 0
    * use no atvars
    if "`noatvars'"=="noatvars" {
        matrix `atintable' = J(1,1,.)
    }
    else if "`atvars'" == "" {
        if `isatvarying' {
            matrix `atintable' = `atvarying'
        }
        else {
            local noatvars "noatvars"
            matrix `atintable' = J(1,1,.)
        }
    }
    else if "`atvars'" == "_all" {
        matrix `atintable' = r(at)
        local at11 = `atintable'[1,1]
        if (`at11'==.) local noatvars "noatvars"
    }
    * atvars specified
    else {
        matrix `atsrc' = r(at)
        local atnms : colnames `atsrc'
        local natnms = wordcount("`atnms'")
        local natvars = 0
        foreach atvarnm of local atvars {
            local ipos : list posof "`atvarnm'" in atnms
            if `ipos'==0 {
                display as error ///
                    "`atvarnm' not in r(at) matrix: `atnms'"
                local error = 1
                continue, break
            }
            else {
                local ++natvars
            }
            matrix `atvec' = `atsrc'[1...,`ipos']
            matrix `atintable' = nullmat(`atintable') , `atvec'
        }
        if (`natvars'==`natnms') local noatprint = 1
        if ("`error'"=="1") exit
    }
    local ncolsat = colsof(`atintable')

 //  contruct current matrix

    * wide results
    capture matrix drop _mtab_W
    capture matrix drop _mtab_Wat
    capture matrix drop _mtab_Wstat
    foreach stat of local statlist {
        local matnm `nm_`stat''
        local statnm `nm_`stat''
        if "`stat'"=="estimate" {
            local matnm "estimate"
            local statnm `nm_estimate'
        }
        capture matrix drop _mtab_`matnm'
        local ipos : list posof "`stat'" in tablecolnms
        if `multipleoutcomes' {
            local colnms ""
            foreach ival of numlist `outcomes' {
                local inm "`ival'"
                if "`yLabelName'"!="" & "`nolabels'"!="nolabels" {
                    local inm : label `yLabelName' `ival' `valuelength'
                }
                local statcolnm "`statnm'"
                if ("`statnm'"=="pvalue") local statcolnm "p"
                if `wide' {
                   local colnms "`colnms' `statcolnm'_`colstub'`inm'"
                }
                else {
                    local colnms "`colnms' `colstub'`inm'"
                }
                matrix `ivec' = tableuse_`ival'[1...,`ipos']
                matrix _mtab_`matnm' = nullmat(_mtab_`matnm') , `ivec'
            }
            matrix colnames _mtab_`matnm' = `colnms'
*di "3 colnms: `colnms'"
        }
        if `singleoutcome' {
            local singlecolnms "`statcolnms' `nm_`stat''"
            matrix `ivec' = `tbluse'[1...,`ipos']
            matrix _mtab_`matnm' = nullmat(_mtab_`matnm') , `ivec'
            matrix colnames _mtab_`matnm' = `colstub'`statnm'
        }
        local rownms : rownames _mtab_`matnm'
        local rownms : subinstr local rownms "._at" "", all
        local rownms : subinstr local rownms "bn" "", all
        if ("`rownms'"=="_cons") local rownms "_"
        matrix rownames _mtab_`matnm' = `rownms'
        matrix roweq _mtab_`matnm' = `roweqnm'
        matrix coleq _mtab_`matnm' = `coleqnm'
        matrix _mtab_W = nullmat(_mtab_W) , _mtab_`matnm'
        capture drop _mtab_`matnm'

    } // over stats
    matrix _mtab_Wstat = _mtab_W
    local ncolsWstat = colsof(_mtab_Wstat)

    if ("`noatvars'"=="noatvars") local ncolsWat = 0
    else if "`atright'"=="atright" {
        matrix _mtab_W = _mtab_Wstat, `atintable'
        matrix _mtab_Wat = `atintable'
        local ncolsWat = colsof(_mtab_Wat)
    }
    else { // atvars on left
        matrix _mtab_W = `atintable', _mtab_W
        matrix _mtab_Wat = `atintable'
        local ncolsWat = colsof(_mtab_Wat)
    }

    * long list
    capture matrix drop _mtab_L
    capture matrix drop _mtab_Lcols
    capture matrix drop _mtab_Lstat
    capture matrix drop _mtab_Lat
    local statnm : word 1 of `statlist'
    local matstatnm `nm_`statnm''
*di "4 expname: `expname'"
    if ("`statnm'"=="estimate") local matstatnm "estimate"
    local rownms ""
    capture matrix drop `outmat'
    forvalues irow = 1(1)`nrows' {
        local istat = 0
        if "`noatvars'"=="" {
            matrix `atvec' = `atintable'[`irow',1...]
        }
        foreach stat of local statlist {
            local ++istat
            local matstatnm `nm_`stat''
            local statlabel "`matstatnm'"
            if "`stat'" == "estimate" {
                local matstatnm estimate
                local statlabel "`estname'"
            }
*di "5 statlabel: `statlabel'"
*di "6 matstatnm: `matstatnm'"
            local rownms "`rownms' `statlabel'"
            matrix `ivec' = _mtab_`matstatnm'[`irow',1...]
            matrix _mtab_L = nullmat(_mtab_L) \ `ivec'
            if "`noatvars'"=="" {
                matrix `atL' = nullmat(`atL') \ `atvec'
            }
        }
    }
*di "7 rownms: `rownms'"
    matrix _mtab_Lstat = _mtab_L
    local ncolsLstat = colsof(_mtab_Lstat)
    if "`noatvars'"=="noatvars" {
        local ncolsLat = 0
        local currorder "stat"
    }
    else if "`atright'"=="atright" {
        local currorder "stat at"
        matrix _mtab_L = _mtab_L, `atL'
        matrix _mtab_Lat = `atL'
        local ncolsLat = colsof(`atL')
    }
    else {
        local currorder "at stat"
        matrix _mtab_L = `atL', _mtab_L
        matrix _mtab_Lat = `atL'
        local ncolsLat = colsof(`atL')
    }
    matrix rownames _mtab_L = `rownms'
    matrix rownames _mtab_Lstat = `rownms'
    local nrowsW = rowsof(_mtab_W)
    local nrowsL = rowsof(_mtab_L)
    local ncolsW = colsof(_mtab_W)
    local ncolsL = colsof(_mtab_L)

//  row names

    if "`rowstub'"!="" | "`rowname'"!="" {
        local isname = 0
        if "`rowname'"!="" {
            local rowname : subinstr local rowname " " "_", all
            local rowstub ""
            local isname = 1
            local isstub = 0
            local rnm "`rowname'"
        }
        else { // stub
            local isname = 0
            local isstub = 1
            local rnm "`rowstub'"
        }
        foreach type in W L {
            matrix mat = _mtab_`type'
            local nms : rownames mat
            local nrows = rowsof(mat)
            local newnms ""
            local ivec = 0
            foreach nm in `nms' {
                local ++ivec
                if "`nm'"=="" | "`nm'"=="_" {
                    if (`nrows'==1) local nm "`rnm'"
                    else local nm "`rnm'_`ivec'"
                }
                else { // row is names
                    * 1.factor causes error
                    local nm : subinstr local nm "." "_", all
                    if `isstub' local nm "`rnm'_`nm'"
                    if `isname' local nm "`rnm'"
                }
                local newnms "`newnms'`nm' "
            }
            matrix rownames mat = `newnms'
            if ("`names'"=="columns" & `nonamesopt') local names "all"
            if ("`names'"=="none" & `nonamesopt') local names "rows"
            matrix _mtab_`type' = mat
            if "`noatvars'"=="" {
                matrix mat = _mtab_`type'at
                local nms : rownames mat
                local newnms ""
                local ivec = 0
                foreach nm in `nms' {
                    local ++ivec
                    if "`nm'"=="" | "`nm'"=="_" {
                        if (`nrows'==1) local nm "`rowstub'"
                        else local nm "`rowstub'_`ivec'"
                    }
                    else {
                        local nm "`rowstub'_`nm'"
                    }
                    local newnms `"`newnms'`"`nm'"' "'
                }
                matrix rownames mat = `newnms'
                matrix _mtab_`type'at = mat
            }
            capture matrix drop mat
        } // type
    } // rowstub

//  row and col eq names

    * remove at var name used as roweq
    if "noatvars"=="`noatvars'" {
        matrix roweq _mtab_W = ""
        matrix roweq _mtab_L = ""
    }
    if "`roweqnm'"!="" {
        matrix roweq _mtab_W = `roweqnm'
        matrix roweq _mtab_L = `roweqnm'
        if "`noatvars'"=="" {
            matrix roweq _mtab_Wat = `roweqnm'
            matrix roweq _mtab_Lat = `roweqnm'
        }
        matrix roweq _mtab_Wstat = `roweqnm'
        matrix roweq _mtab_Lstat = `roweqnm'
        if ("`names'"=="columns" & `nonamesopt') local names "all"
        if ("`names'"=="none" & `nonamesopt') local names "rows"
    }
    if "`coleqnm'"!="" {
        matrix coleq _mtab_W = `coleqnm'
        matrix coleq _mtab_L = `coleqnm'
        if "`noatvars'"=="" {
            matrix coleq _mtab_Wat = `coleqnm'
            matrix coleq _mtab_Lat = `coleqnm'
        }
        matrix coleq _mtab_Wstat = `coleqnm'
        matrix coleq _mtab_Lstat = `coleqnm'
        if ("`names'"=="row" & `nonamesopt') local names "all"
        if ("`names'"=="none" & `nonamesopt') local names "cols"
    }
    matrix _mtab_L = _mtab_L
    matrix _mtab_W = _mtab_W
    matrix `currentmat' = _mtab_`LW'
    matrix _mtab_displayed = `currentmat'

    if `multipleoutcomes' {
        foreach ival of numlist `outcomes' {
            capture matrix drop tableuse_`ival'
        }
    }
    if `singleoutcome' & `right' & `long' {
        if ("`names'"=="columns" & `nonamesopt') local names "all"
        if ("`names'"=="none" & `nonamesopt') local names "rows"
    }

    * if _mtab_displayed has prior roweq name, display it
    local tmpnm : roweq _mtab_displayed
    local tmpnm : subinstr local tmpnm "_" "", all
    local tmpnm : subinstr local tmpnm " " "", all
    if "`tmpnm'"!="" {
        if ("`names'"=="columns" & `nonamesopt') local names "all"
        if ("`names'"=="none" & `nonamesopt') local names "rows"
    }

//  cpsec for current matrix

    local reqnm : roweq _mtab_displayed
    local reqnm : word 1 of `reqnm'
    local rlen = strlen("`reqnm'")
    local nmlen = `rlen' + 1
    if (`nmlen'<9) local nmlen = 9
    * check row names
    local rnms : rownames _mtab_displayed
    capture local rnms : rownames _mtab_stack // use stack if it exits
    local rnmlen = 0
    foreach nm in `rnms' {
        local rlen = strlen("`nm'") + 1
        if (`rlen'>`rnmlen') local rnmlen = `rlen'
    }
    if (`rnmlen'>`nmlen') local nmlen = `rnmlen'
    if `twidth'>0 local nmlen = `twidth'

    local nrows = rowsof(_mtab_displayed)

    local cspec_names "o1& %`nmlen's |" // used for names(rows) or names(all)
    local addnames = 0
    if `multipleoutcomes' & `nstats'>1 {
        local addnames = 1
        if ("`names'"=="columns" & `nonamesopt') local names "all"
        if ("`names'"=="none" & `nonamesopt') local names "rows"
    }
    local currCat = `ncolsat'
    local currCstat = `ncols`LW'stat'
    local currRat = rowsof(`currentmat')
    * cpsec for current at
    local currcpsec_at ""
    forvalues i = 1(1)`currCat' { // use g format for at matrix
        local currcpsec_at "`currcpsec_at' %`width'.`decimals'g &"
    }

    * cpsec for current matrix
    local currcspec_stat ""
    forvalues i = 1(1)`currCstat' {
        local currcspec_stat "`currcspec_stat' %`width'.`decimals'f &"
    }
    local cspec ""
    foreach nm in `currorder' {
        if ("`nm'"=="at") local cspec "`cspec' `currcpsec_at'"
        if ("`nm'"=="stat") local cspec "`cspec' `currcspec_stat'"
    }
    if "`names'"=="all" | "`names'"=="rows" {
        local cspec "`cspec_names' `cspec'" // add column for name
    }
    else local cspec `"& `cspec'"'
    local rspec "&"
    if ("`names'"=="all" | "`names'"=="columns") local rspec "`rspec'-"
    forvalues i = 1(1)`nrows' {
        local rspec "`rspec'&"
    }

//  stack

    local priorcspec "$mtab_cspec "
    local priorrspec "$mtab_rspec "
    local priortype  "$mtab_type"
    local priorexp   "$mtab_expression"
    local priorcpsecnames "$mtab_cspecnames"
/*
di "cspec:  !`cspec'!"
di "Pcspec: !`priorcspec'!"
di "rspec:  !`rspec'!"
di "Prspec: !`priorrspec'!"
*/
    if `dostack' {
        if "`LW'"!="`priortype'" {
            display as error ///
"when stacking, current and prior matrix must both be long or both wide"
            exit
        }
        if `right' {
            local nrowsstack = rowsof(_mtab_stack)
            local nrowsdisp = rowsof(_mtab_displayed)
            if `nrowsstack'!=`nrowsdisp' {
                display as error ///
                    "current table does not match rows of saved table"
                exit
            }
            matrix _mtab_displayed = _mtab_stack, _mtab_displayed
            local is_cnames = strpos("`cspec'","`cspec_names'")
            * if names specification, remove names cspec portion of cpsec
            if `is_cnames'>0 {
                local cspectrim = subinstr("`cspec'","`cspec_names'"," ",1)
            }
            else {
                local cspectrim = subinstr("`cspec'","&"," ",1)
            }
            * if no row names, remove names spec from prior
            if "`names'"=="none" | "`names'"=="columns" {
                local priorcspec ///
                    = subinstr("`priorcspec'","$mtab_cspecnames"," ",1)
                local priorcspec "& `priorcspec'"
            }
            local cspec "`priorcspec' `cspectrim'"
        }
        if `below' {
            local ncolsstack = colsof(_mtab_stack)
            local ncolsdisp = colsof(_mtab_displayed)
            if `ncolsstack'!=`ncolsdisp' {
                display as error ///
                    "current table does not match columns of saved table"
                exit
            }
            matrix _mtab_displayed = _mtab_stack \ _mtab_displayed
            local rspectrim = subinstr("`rspec'","&-","",1)
            local rspec "`priorrspec' `rspectrim'"
        }
        local cspec = subinstr("`cspec'","& &","&",1)
    }
/*
di "cspec:  !`cspec'!"
di "rspec:  !`rspec'!"
*/
    global mtab_cspec "`cspec'"
    global mtab_rspec "`rspec'"
    global mtab_type  "`LW'"
    global mtab_cspecnames "`cspec_names'"

//  print results

*    display
    if ("`mytitle'"!="") display _new "{bf}`mytitle'{sf}"
    global mtab_expression "`explabel'`expout'"
    if `dostack' & `stackexists' {
        * too confusing
        * display "Expressions: `explabel'`expout'"
        * display "Prior      : `priorexp'"
    }
    else {
        display _new "Expression: `explabel'`expout'"
    }

if "nobs"=="`nobs'" {
    di "N = `nobsis'"
}

    matlist _mtab_displayed, names(`names') title("") ///
        cspec(`cspec') rspec(`rspec') /// 0.8.0
        underscore // blank row if _ is name

    if "`mlistat'"=="mlistat" {
        mlistat
    }
    * don't list if stacked
    else if (`isatconstant'==1) & "`noatvars'"=="" ///
        & !`stackexists' & `noatprint'==0 {
        matlist `atconstant', format(%9.3f) names(col) ///
        title("Constant values of at() variables")
    }

    matrix _mtab_stack = _mtab_displayed
    capture matrix drop priormtab_Lstat
    capture matrix drop priormtab_Lat
    capture matrix drop priormtab_Wstat
    capture matrix drop priormtab_Wat
    capture matrix drop _mtab_L
    capture matrix drop _mtab_W
    capture matrix drop _mtab_Lstat
    capture matrix drop _mtab_Wstat

end

program define _MarginsParse, sclass

    syntax ,[    ///
            post /// need to block margins post
            PRedict(string asis) /// predict option
            EXPression(string asis) /// expression option
            * /// everything else will get passed along
            ]

    if "`post'" != "" {
        display as error ///
        "posting margins results not allowed with mtable"
        error 999
    }
    if "`predict'" != "" {
        sreturn local predictused "TRUE"
        local PredictText "predict(`predict')"
    }
    if "`expression'" != "" {
        sreturn local expressionused "TRUE"
        local ExpressionText "expression(`expression')"
    }
    sreturn local options "`options' `PredictText' `ExpressionText'"
end

// type of model based on predict behavior

program define _GetModelType, sclass

    tempname TestVariable DefaultPred
    qui sum `e(depvar)'
    local MinValue = r(min)
    * obtain default values under predict
    quietly predict `DefaultPred'
    * test if outcome() type prediction
    capture quietly predict `TestVariable', outcome(`MinValue')
    if (_rc==0) local ExpType "outcome"
    * test if pr() type prediction
    if "`ExpType'" == "" {
        capture quietly predict `TestVariable', pr(`MinValue')
        if (_rc==0) local ExpType "pr"
        * in case non integer count
        if (_rc==198 & "`force'"=="force") local ExpressionType "pr"
    }
    * test if p is supported and equals default
    if "`ExpType'" == "" {
        capture quietly predict `TestVariable', p
        if _rc == 0 {
            if (`TestVariable'==`DefaultPred') local ExpType "p"
        }
    }
    sreturn local ExpType "`ExpType'"
end

program define _parse_stat, sclass
    local isbad = 1
    local stat "`1'"
    local is = inlist("`stat'","e","es","est","esti","estim","estima")
    if `is'==1 {
        local stat "estimate"
        local isbad = 0
    }
    local is = inlist("`stat'","estimat","estimate","coef")
    if `is'==1 {
        local stat "estimate"
        local isbad = 0
    }
    local is = inlist("`stat'","s","se","stderr")
    if `is'==1 {
        local stat "se"
        local isbad = 0
    }
    local is = inlist("`stat'","p","pv","pva","pval","pvalu","pvalue")
    if `is'==1 {
        local stat "pvalue"
        local isbad = 0
    }
    local is = inlist("`stat'","z","zv","zva","zval","zvalu","zvalue")
    if `is'==1 {
        local stat "z"
        local isbad = 0
    }
    local is = inlist("`stat'","upper","ub","u","ul")
    if `is'==1 {
        local stat "ul"
        local isbad = 0
    }
    local is = inlist("`stat'","lower","lb","l","ll")
    if `is'==1 {
        local stat "ll"
        local isbad = 0
    }
    sreturn local stat "`stat'"
    sreturn local isbad "`isbad'"
end

exit

* version 0.3.1 2012-09-13 | long freese | new command based on mgen3
* version 0.5.0 2012-09-14 | long freese | first mtable
* version 0.5.1 2012-09-14 | long freese | first mtable
* version 0.5.2 2012-09-14 | long freese | first mtable
* version 0.5.3 2012-09-17 | long freese | tpoisson
* version 0.5.4 2012-09-17 | long freese | other count predictions
* version 0.5.5 2012-09-17 | long freese | stack
* version 0.5.6 2012-09-17 | long freese | stack tweaks
* version 0.5.7 2012-09-17 | long freese | stack default; split option; _none
* version 0.5.8 2012-09-17 | long freese | _rm_marginsinfo
* version 0.6.0 2012-09-17 | long freese | add and append
* version 0.6.1 2012-09-21 | long freese | attoff and names if long print
* version 0.6.2 2012-09-21 | long freese |
* version 0.7.0 2012-09-21 | long freese | save _long _wide
* version 0.7.1 2012-09-21 | long freese | col type matrix
* version 0.7.2 2012-09-25 | long freese | cpr
* version 0.7.3 2012-09-25 | long freese | prior label when merged
* version 0.7.4 2012-10-03 | long freese | minor fixes
* version 0.7.5 2012-10-06 | long freese | stack option
* version 0.7.6 2012-10-08 | long freese | atoff and mlistat; predname; rownm
* version 0.7.15 2012-11-27 | long freese | fix extra matlist
* version 0.7.14 2012-11-18 | long freese | fix _ label
* version 0.7.13 2012-11-18 | long freese | echo margins; list roweq always
* version 0.7.12 2012-11-18 | long freese | dydx() label
* version 0.7.11 2012-10-29 | long freese | rowname() fix factor var
* version 0.7.10 2012-10-29 | long freese | rowname()
* version 0.7.9 2012-10-29 | long freese | refine output; coeqnm if stack
* version 0.7.8 2012-10-09 | long freese | refine select on stats
* version 0.7.7 2012-10-08 | long freese | fix right bug; rownms; _none bug
* version 0.7.18 2013-01-21 | long freese | gologit2 error
* version 0.7.16 2012-11-27 | long freese | ok to stack if no prior stack
* version 0.8.6 2013-02-21 | long freese | minor parse fix
* version 0.8.5 2013-02-20 | long freese | overhall of right and left
* version 0.8.4 2013-02-20 | long freese | add stack back in!
* version 0.8.3 2013-02-20 | long freese | clean stack
* version 0.8.2 2013-02-20 | long freese | stat()
* version 0.8.1 2013-02-20 | long freese | noatvar atvar fixes
* version 0.8.0 2013-02-17 | long freese | if atvar() don't show varying atvars
