{smcl}
{* 2013-04-22 scott long}{...}
{hi:help mtable}{right:See also: {helpb spost13}, {helpb margins}}
{hline}

{title:Saving margins results to a table}

{p2colset 5 16 24 2}{...}
{p2col:{cmd:mtable} {hline 2}}Run margins over all outcomes and create a table{p_end}
{p2colreset}{...}

{marker overview}
{title:Overview}

{pstd}
{cmd:mtable} runs the {cmd:margins} command and saves the results to a
table. If the outcome has multiple categories, it will automatically
submits multiple {cmd:margins} commands for all outcomes and combine the
results.
You can use {cmd:margins} options as options for {cmd:mtable} and these
will be passed to {cmd:margins}.
{p_end}

{pstd}
{bf:Warning:} {cmd:margins} is a complicated command with many options.
It is possible that {cmd:mtable} will not work with every option that is
available with {cmd:margins}.
{p_end}


{title:General syntax}

{p 4 18 2}
{cmd:mtable}[{it:if}] [{it:in}]{cmd:,} [ {it:options} ]
{p_end}


{title:Table of contents}

    {help mtable##stats:Which statistics to display}
    {help mtable##atvars:Displaying at-variables}
    {help mtable##show:Controlling how results are displayed}
    {help mtable##combine:Combining tables}
    {help mtable##matrices:Matrices that are created}


{title:Options}
{marker stats}
{dlgtab:Statistics to include in the table}
{p2colset 7 24 25 0}
{p 6 6 2}

{synopt:{opt stat:istics(statlist)}}specifies which statistics to
include in the table. By default the estimates and confidence interval
are displayed.
{p_end}

{p2colset 10 23 23 12}{...}
{p2col :Name}Description{p_end}
{p2line}
{p2col :{ul:{bf:est}}{bf:imate}}Estimated margins including probabilities, dydx, etc.{p_end}
{p2col :{bf:ll}}Lower level bound of confidence interval{p_end}
{p2col :{bf:ul}}Upper level bound of confidence interval{p_end}
{p2col :{bf:pvalue}}p-value for test margin is 0{p_end}
{p2col :{bf:se}}Standard error of margin{p_end}
{p2col :{bf:z}}z-value{p_end}
{p2col :{bf:all}}Display all statistics{p_end}
{p2col :{bf:ci}}Display estimate, ll, and ul{p_end}
{p2line}
{p2colset 8 24 25 0}
{synopt:{opt allstats}}
includes all statictics.

{synopt:{opt ci}}
display estimate and bounds of confidence interval.

{synopt:{opt pv:alue}}
display estimate and p-value.

{synopt:{opt cpr}}
Show conditional prediction for count models.
{p_end}

{synopt:{opt out:comes(numlist)}}estimates for these outcomes are shown.
{cmd:outcomes()} requires the estimation model to be
"categorical", "binary", or "count", where these are
defined by the behavior of the {cmd:predict} command as described
under "Model Types" in {helpb mgen}.
Outcome values must be non-negative integers.
{p_end}


{marker atvars}
{dlgtab:Including at-variables in the table}
{p2colset 7 24 25 0}
{p 6 6 2}
By default, the table includes all at-variables that vary.
These options control which at-variables to include in the table.
{p_end}

{synopt:{opt atv:ars(varlist)}}specifies which at-variables to
include in the table.
{bf:atvars(_none)} excludes all at-variables.
{bf:atvars(_all)} includes all at-variables including those that do not vary.
{p_end}

{synopt:{opt noat:vars}}Do not include any at-variables in table.
This is equivalent to {cmd:atvars(_none)}.
{p_end}

{synopt:{opt atr:ight}}By default, the at-variables are listed
before the estimates. {bf:atright} places the at-variables to the
right.
{p_end}

{synopt:{opt mlistat}}Run {cmd:mlistat} after displaying the table.}.
{p_end}


{marker show}
{dlgtab:Controlling how results are displayed}
{p2colset 7 24 25 0}
{synopt:{opt long}}
Print table with statistics in rows.

{synopt:{opt wide}}
Print table with statistics in columns. Column names with include the
names of the statistics.

{synopt:{opt roweq:nm}}
Add a row equation name to the table.

{synopt:{opt coleq:nm}}
Add a column equation name to the table.

{synopt:{opt rowst:ub(string)}}
Add this string to the names labeling the rows.

{synopt:{opt colst:ub(string)}}
Add this string to the names labeling the columns.

{synopt:{opt rowna:me(string)}}
Use this name to label the row.

{synopt:{opt title(string)}} Display {it:string}
above the results.

{synopt:{opt d:etails}}
Display output from {cmd:margins}.

{synopt:{opt tw:idth(#)}}Specify the row label (text) width.

{synopt:{opt wid:th(#)}}Specify the width of the columns.

{synopt:{opt dec:imal(#)}} Set the number of decimal digits displayed.

{synopt:{opt estn:ame(string)}}Name to label estimates. By
default the name from {cmd:margins} is used.

{synopt:{opt nol:abel}}do not use value labels when labeling outcomes.
{p_end}

{synopt:{opt noobs}}Display number of observations used by {cmd:margins}.
{p_end}


{synopt:{opt valuel:ength(#)}}limits length of value labels used to
label results to the first # characters.
{p_end}

{synopt:{opt names(rows|columns|all|none)}}indicates if row names,
column names, all (row and column) names, or no names will be shown in
table. See {cmd:matlist} for details. This option overwrites the
defaults and can lead to poorly formatted output.
{p_end}

{marker combine}
{dlgtab:Combining tables}
{p2colset 7 24 25 0}
{p 6 6 2}
You can combine results from the current {cmd:mtable} with those
from the last {cmd:mtable}. You can build tables using
as many {cmd:mtable} commands as needed.
{p_end}

{synopt:{opt below}}
Place current table below those from last {cmd:mtable}.
{p_end}

{synopt:{opt right}}
Place current table to the right of those from last {cmd:mtable}.
{p_end}

{synopt:{opt clear:stack}}
Clear any stacked results before beginning a new stack with the current
results.
{p_end}


{marker matrices}
{dlgtab:Matrices that are created}

{p2colset 7 24 25 0}
{p 6 6 2}
Matrices with the displayed results are saved to memory.
{p_end}

{p2colset 10 29 29 12}{...}
{p2col :Name}Description{p_end}
{p2line}
{p2col :{bf:_mtab_displayed}}The displayed table{p_end}
{p2col :{bf:_mtab_estimate}}Table of estimates if stat(estimates) was used{p_end}
{p2col :{bf:_mtab_ll}}Table of lower bounds if stat(ll) was used{p_end}
{p2col :{bf:_mtab_ul}}Table of upper bounds if stat(lb) was used{p_end}
{p2col :{bf:_mtab_pvalue}}Table of pvalues if stat(pvalue) was used{p_end}
{p2col :{bf:_mtab_se}}Table of standard errors if stat(se) was used{p_end}
{p2col :{bf:_mtab_z}}Table of z-values if stat(estimates) was used{p_end}
{p2line}


{marker examples}{...}
{title:Examples}

    {hline}


    {hline}


    {hline}


{title:Also see}

{pstd}
Manual: {hi:[R] margins}

INCLUDE help spost13_footer
